/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mm.bean;

import com.mm.domen.Kupac;
import com.mm.domen.KupacFizickoLice;
import com.mm.domen.KupacPravnoLice;
import com.mm.domen.Mesto;
import com.mm.service.KupacService;
import com.mm.service.MestoService;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.bean.SessionScoped;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/**
 *
 * @author vojkan
 */

@Component
//@ManagedBean
@Scope(value = "request")
public class ObradaKupca {
    
    @Autowired
    private KupacService kupacService;

    @Autowired
    private MestoService mestoService;

    private List<Mesto> mesta;
    
    private List<Kupac> kupci;
    
    Kupac kupac;
    
    public int vrstaKupca = 1;  // 1. Fizicko Lice 2. Pravno Lice
        
    public ObradaKupca() {
        kupac = new KupacFizickoLice();
    }

    @PostConstruct
    public void init(){
        
        mesta = mestoService.findAll();
        kupci = kupacService.findAll();
    }

    
    public void setMestoService(MestoService mestoService) {
        this.mestoService = mestoService;
    }

    public List<Mesto> getMesta() {
        return mesta;
    }

    public void setMesta(List<Mesto> mesta) {
        this.mesta = mesta;
    }

    public Kupac getKupac() {
        return kupac;
    }

    public void setKupac(Kupac kupac) {
        this.kupac = kupac;
    }

    public int getVrstaKupca() {
        return vrstaKupca;
    }

    public void setVrstaKupca(int vrstaKupca) {
        this.vrstaKupca = vrstaKupca;
    }

    public List<Kupac> getKupci() {
        return kupci;
    }

    public void setKupci(List<Kupac> kupci) {
        this.kupci = kupci;
    }
    
    
    
    public String sacuvajKupca(){
        
        kupac = kupacService.save(kupac);
        
        FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Kupac je uspesno sacuvan!!!", ""));
        
        return null;
    }
    
    public void promenioSeTipKupca(ValueChangeEvent vce){
        System.out.println("vrsta kupca:"+vrstaKupca);
        
    }
    public void promenioSeTipKupca(){
        
        System.out.println("vrsta kupca:"+vrstaKupca);
        if (vrstaKupca==1){
            KupacFizickoLice kupacFL = new KupacFizickoLice();
            kupac = kupacFL;
        } else {
            KupacPravnoLice kupacPL = new KupacPravnoLice();
            kupac = kupacPL;
        }
    }
    
    public int vratiTip(Kupac k){
        if (k instanceof KupacFizickoLice) return 1;
        if (k instanceof KupacPravnoLice) return 2;
        return 0;
    }
    
    public String pokreniIzmenu(Kupac k){
        
        if (k instanceof KupacFizickoLice) this.vrstaKupca = 1;
        if (k instanceof KupacPravnoLice) vrstaKupca = 2;
        
        kupac = k;
        
        return "unos_kupca.xhtml";
        
    }
}
