package com.mm.bean;

import com.mm.domen.Mesto;
import com.mm.service.KupacService;
import com.mm.service.MestoService;
import java.io.IOException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
@ManagedBean
@ViewScoped
public class SvaMestaBean {

    @Autowired
    private MestoService mestoService;

    
    private List<Mesto> mesta;

    public List<Mesto> getMesta() {
        return mesta;
    }

    public void setMesta(List<Mesto> mesta) {
        this.mesta = mesta;
    }

    @PostConstruct
    public void init() {
        mesta = mestoService.findAll();
    }

    public void vratiNaStart(){
        
        FacesContext context = FacesContext.getCurrentInstance();
        try {
            System.out.println("pozvao vrati na start");
            context.getExternalContext().redirect("/action/prijavi_se");
            //return "";
        } catch (IOException ex) {
            Logger.getLogger(SvaMestaBean.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
       //context.responseComplete();
    }
    }
}
